Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/ExtendedPotvin/Creators/PushForwardInsertionCreator.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/ExtendedPotvin/Creators/PushForwardInsertionCreator.cs	(revision 6851)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/ExtendedPotvin/Creators/PushForwardInsertionCreator.cs	(revision 6851)
@@ -0,0 +1,320 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+using HeuristicLab.Problems.VehicleRouting.ProblemInstances;
+using HeuristicLab.Problems.VehicleRouting.Variants;
+
+namespace HeuristicLab.Problems.VehicleRouting.Encodings.ExtendedPotvin {
+  [Item("PushForwardInsertionCreator", "Creates a randomly initialized VRP solution.")]
+  [StorableClass]
+  public sealed class PushForwardInsertionCreator : ExtendedPotvinCreator, IStochasticOperator {
+    #region IStochasticOperator Members
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (LookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    #endregion
+
+    public IValueParameter<DoubleValue> Alpha {
+      get { return (IValueParameter<DoubleValue>)Parameters["Alpha"]; }
+    }
+    public IValueParameter<DoubleValue> AlphaVariance {
+      get { return (IValueParameter<DoubleValue>)Parameters["AlphaVariance"]; }
+    }
+    public IValueParameter<DoubleValue> Beta {
+      get { return (IValueParameter<DoubleValue>)Parameters["Beta"]; }
+    }
+    public IValueParameter<DoubleValue> BetaVariance {
+      get { return (IValueParameter<DoubleValue>)Parameters["BetaVariance"]; }
+    }
+    public IValueParameter<DoubleValue> Gamma {
+      get { return (IValueParameter<DoubleValue>)Parameters["Gamma"]; }
+    }
+    public IValueParameter<DoubleValue> GammaVariance {
+      get { return (IValueParameter<DoubleValue>)Parameters["GammaVariance"]; }
+    }
+
+    [StorableConstructor]
+    private PushForwardInsertionCreator(bool deserializing) : base(deserializing) { }
+
+    public PushForwardInsertionCreator()
+      : base() {
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator."));
+      Parameters.Add(new ValueParameter<DoubleValue>("Alpha", "The alpha value.", new DoubleValue(0.7)));
+      Parameters.Add(new ValueParameter<DoubleValue>("AlphaVariance", "The alpha variance.", new DoubleValue(0.5)));
+      Parameters.Add(new ValueParameter<DoubleValue>("Beta", "The beta value.", new DoubleValue(0.1)));
+      Parameters.Add(new ValueParameter<DoubleValue>("BetaVariance", "The beta variance.", new DoubleValue(0.07)));
+      Parameters.Add(new ValueParameter<DoubleValue>("Gamma", "The gamma value.", new DoubleValue(0.2)));
+      Parameters.Add(new ValueParameter<DoubleValue>("GammaVariance", "The gamma variance.", new DoubleValue(0.14)));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PushForwardInsertionCreator(this, cloner);
+    }
+
+    private PushForwardInsertionCreator(PushForwardInsertionCreator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    // use the Box-Mueller transform in the polar form to generate a N(0,1) random variable out of two uniformly distributed random variables
+    private static double Gauss(IRandom random) {
+      double u = 0.0, v = 0.0, s = 0.0;
+      do {
+        u = (random.NextDouble() * 2) - 1;
+        v = (random.NextDouble() * 2) - 1;
+        s = Math.Sqrt(u * u + v * v);
+      } while (s < Double.Epsilon || s > 1);
+      return u * Math.Sqrt((-2.0 * Math.Log(s)) / s);
+    }
+
+    private static double N(double mu, double sigma, IRandom random) {
+      return mu + (sigma * Gauss(random)); // transform the random variable sampled from N(0,1) to N(mu,sigma)
+    }
+
+    private static double GetDistance(int start, int end, IVRPProblemInstance problemInstance) {
+      double distance = 0.0;
+
+      double startX = problemInstance.Coordinates[start, 0];
+      double startY = problemInstance.Coordinates[start, 1];
+
+      double endX = problemInstance.Coordinates[end, 0];
+      double endY = problemInstance.Coordinates[end, 1];
+
+      distance =
+          Math.Sqrt(
+            Math.Pow(startX - endX, 2) +
+            Math.Pow(startY - endY, 2));
+
+      return distance;
+    }
+
+    private static ExtendedPotvinEncoding CreateSolution(IVRPProblemInstance problemInstance, IRandom random,
+      double alphaValue = 0.7, double betaValue = 0.1, double gammaValue = 0.2,
+      double alphaVariance = 0.5, double betaVariance = 0.07, double gammaVariance = 0.14) {
+      ExtendedPotvinEncoding result = new ExtendedPotvinEncoding(problemInstance);
+
+      double alpha, beta, gamma;
+      alpha = N(alphaValue, Math.Sqrt(alphaVariance), random);
+      beta = N(betaValue, Math.Sqrt(betaVariance), random);
+      gamma = N(gammaValue, Math.Sqrt(gammaVariance), random);
+
+      int totalTours = 0;
+
+      double distance = 0;
+      double cost = 0;
+      List<int> unroutedList = new List<int>();
+      List<double> costList = new List<double>();
+
+      IPickupAndDeliveryProblemInstance pdp = problemInstance as IPickupAndDeliveryProblemInstance;
+      IMultiDepotProblemInstance mdp = problemInstance as IMultiDepotProblemInstance;
+
+      int depots = 1;
+      if (mdp != null) {
+        depots = mdp.Depots.Value;
+        for (int i = 0; i < result.VehicleAssignment.Length; i++)
+          result.VehicleAssignment[i] = -1;
+      }
+
+      List<int> unrouted = new List<int>();
+      for (int i = 1; i <= problemInstance.Cities.Value; i++)
+        if (pdp == null || problemInstance.GetDemand(i) >= 0)
+          unrouted.Add(i);
+
+      for (int depot = 0; depot < depots; depot++) {
+        int vehicleCount = problemInstance.Vehicles.Value;
+        List<int> vehicles = new List<int>();
+        if (mdp != null) {
+          vehicleCount = 0;
+          for (int i = 0; i < mdp.VehicleDepotAssignment.Length; i++) {
+            if (mdp.VehicleDepotAssignment[i] == depot) {
+              vehicleCount++;
+              vehicles.Add(i);
+            }
+          }
+        } else {
+          for (int i = 0; i < problemInstance.Vehicles.Value; i++)
+            vehicles.Add(i);
+        }
+
+        costList.Clear();
+        unroutedList.Clear();
+
+        double x0 = problemInstance.Coordinates[depot, 0];
+        double y0 = problemInstance.Coordinates[depot, 1];
+
+        /*-----------------------------------------------------------------------------
+        * generate cost list
+        *-----------------------------------------------------------------------------
+        */
+        for (int i = 1; i <= problemInstance.Cities.Value; i++) {
+          //only insert sources
+          if (unrouted.Contains(i) && (pdp == null || problemInstance.GetDemand(i) >= 0)) {
+            distance = GetDistance(i + depots - 1, depot, problemInstance);
+            if (problemInstance.Coordinates[i + depots - 1, 0] < x0) distance = -distance;
+
+            double dueTime = 0;
+            if (problemInstance is ITimeWindowedProblemInstance)
+              dueTime = (problemInstance as ITimeWindowedProblemInstance).DueTime[i];
+
+            cost = -alpha * distance + // distance 0 <-> City[i]
+                   beta * dueTime + // latest arrival time
+                   gamma * (Math.Asin((problemInstance.Coordinates[i + depots - 1, 0] - y0) / distance) / 360 * distance); // polar angle
+
+            int index = 0;
+            while (index < costList.Count && costList[index] < cost) index++;
+
+            costList.Insert(index, cost);
+
+            unroutedList.Insert(index, i);
+          }
+        }
+
+        int tours = 0;
+        double minimumCost = double.MaxValue;
+        int indexOfMinimumCost = -1;
+        int indexOfMinimumCost2 = -1;
+        int indexOfCustomer = -1;
+
+        Tour tour = new Tour();
+        result.Tours.Add(tour);
+        result.VehicleAssignment[totalTours] = vehicles[0];
+        vehicles.RemoveAt(0);
+        tours++;
+        totalTours++;
+
+        tour.Stops.Add(unroutedList[0]);
+
+        if (pdp != null) {
+          tour.Stops.Add(pdp.PickupDeliveryLocation[unroutedList[0]]);
+        }
+
+        unrouted.Remove(unroutedList[0]);
+        unroutedList.RemoveAt(0);
+
+        while (unroutedList.Count > 0 && (tours < vehicleCount || depot == depots - 1)) {
+          for (int c = 0; c < unroutedList.Count; c++) {
+            VRPEvaluation eval = problemInstance.EvaluateTour(tour, result);
+            double originalCosts = eval.Quality;
+            int customer = unroutedList[c];
+
+            for (int i = 0; i <= tour.Stops.Count; i++) {
+              tour.Stops.Insert(i, customer);
+              eval = problemInstance.EvaluateTour(tour, result);
+              double tourCost = eval.Quality - originalCosts;
+
+              if (pdp != null) {
+                for (int j = i + 1; j <= tour.Stops.Count; j++) {
+                  bool feasible;
+                  cost = tourCost +
+                    problemInstance.GetInsertionCosts(eval, result, pdp.PickupDeliveryLocation[unroutedList[c]], 0, j, out feasible);
+                  if (cost < minimumCost && feasible) {
+                    minimumCost = cost;
+                    indexOfMinimumCost = i;
+                    indexOfMinimumCost2 = j;
+                    indexOfCustomer = c;
+                  }
+                }
+              } else {
+                cost = tourCost;
+                bool feasible = problemInstance.Feasible(eval);
+                if (cost < minimumCost && feasible) {
+                  minimumCost = cost;
+                  indexOfMinimumCost = i;
+                  indexOfCustomer = c;
+                }
+              }
+
+              tour.Stops.RemoveAt(i);
+            }
+          }
+
+          // insert customer if found
+          if (indexOfMinimumCost != -1) {
+            tour.Stops.Insert(indexOfMinimumCost, unroutedList[indexOfCustomer]);
+            if (pdp != null) {
+              tour.Stops.Insert(indexOfMinimumCost2, pdp.PickupDeliveryLocation[unroutedList[indexOfCustomer]]);
+            }
+
+            unrouted.Remove(unroutedList[indexOfCustomer]);
+            unroutedList.RemoveAt(indexOfCustomer);
+          } else if (tours < vehicleCount || depot == depots - 1) { // no feasible customer found
+            tour = new Tour();
+            result.Tours.Add(tour);
+            result.VehicleAssignment[totalTours] = vehicles[0];
+            vehicles.RemoveAt(0);
+            tours++;
+            totalTours++;
+
+            tour.Stops.Add(unroutedList[0]);
+            if (pdp != null) {
+              tour.Stops.Add(pdp.PickupDeliveryLocation[unroutedList[0]]);
+            }
+
+            unrouted.Remove(unroutedList[0]);
+            unroutedList.RemoveAt(0);
+          }
+          // reset minimum		
+          minimumCost = double.MaxValue;
+          indexOfMinimumCost = -1;
+          indexOfMinimumCost2 = -1;
+          indexOfCustomer = -1;
+        }
+      }
+
+      if (mdp != null) {
+        List<int> availableVehicles = new List<int>();
+        for (int i = 0; i < mdp.Vehicles.Value; i++)
+          availableVehicles.Add(i);
+
+        for (int i = 0; i < result.VehicleAssignment.Length; i++) {
+          if (result.VehicleAssignment[i] != -1)
+            availableVehicles.Remove(result.VehicleAssignment[i]);
+        }
+
+        for (int i = 0; i < result.VehicleAssignment.Length; i++) {
+          if (result.VehicleAssignment[i] == -1) {
+            result.VehicleAssignment[i] = availableVehicles[0];
+            availableVehicles.RemoveAt(0);
+          }
+        }
+      }
+
+      return result;
+    }
+
+    public override IOperation Apply() {
+      VRPToursParameter.ActualValue = CreateSolution(ProblemInstance, RandomParameter.ActualValue,
+        Alpha.Value.Value, Beta.Value.Value, Gamma.Value.Value,
+        AlphaVariance.Value.Value, BetaVariance.Value.Value, GammaVariance.Value.Value);
+
+      return base.Apply();
+    }
+  }
+}
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/ExtendedPotvin/Crossovers/ExtendedPotvinCrossover.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/ExtendedPotvin/Crossovers/ExtendedPotvinCrossover.cs	(revision 6851)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/ExtendedPotvin/Crossovers/ExtendedPotvinCrossover.cs	(revision 6851)
@@ -0,0 +1,85 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using System.Collections.Generic;
+using HeuristicLab.Problems.VehicleRouting.Encodings.General;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+using HeuristicLab.Common;
+using HeuristicLab.Problems.VehicleRouting.Encodings.Potvin;
+
+namespace HeuristicLab.Problems.VehicleRouting.Encodings.ExtendedPotvin {
+  [Item("ExtendedPotvinCrossover", "A VRP crossover operation.")]
+  [StorableClass]
+  public class ExtendedPotvinCrossover : VRPCrossover, IStochasticOperator, IExtendedPotvinOperator {
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (LookupParameter<IRandom>)Parameters["Random"]; }
+    }
+
+    public IValueParameter<PotvinCrossover> ToursCrossover {
+      get { return (IValueParameter<PotvinCrossover>)Parameters["ToursCrossover"]; }
+    }
+
+    [StorableConstructor]
+    protected ExtendedPotvinCrossover(bool deserializing) : base(deserializing) { }
+
+    public ExtendedPotvinCrossover() {
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic manipulation operators."));
+      Parameters.Add(new ValueParameter<PotvinCrossover>("ToursCrossover",
+        "The operator used to crossover the tours.", new PotvinInsertionBasedCrossover()));
+    }
+
+    protected ExtendedPotvinCrossover(ExtendedPotvinCrossover original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ExtendedPotvinCrossover(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      ItemArray<IVRPEncoding> parents = new ItemArray<IVRPEncoding>(ParentsParameter.ActualValue.Length);
+      for (int i = 0; i < ParentsParameter.ActualValue.Length; i++) {
+        IVRPEncoding solution = ParentsParameter.ActualValue[i];
+
+        if (!(solution is ExtendedPotvinEncoding)) {
+          parents[i] = ExtendedPotvinEncoding.ConvertFrom(solution, ProblemInstance);
+        } else {
+          parents[i] = solution;
+        }
+      }
+      ParentsParameter.ActualValue = parents;
+
+      OperationCollection next = new OperationCollection(base.Apply());
+      
+      ToursCrossover.Value.ParentsParameter.ActualName = ParentsParameter.ActualName;
+      ToursCrossover.Value.ChildParameter.ActualName = ChildParameter.ActualName;
+      next.Insert(0, ExecutionContext.CreateOperation(ToursCrossover.Value));
+
+      return next;
+    }
+  }
+}
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/ExtendedPotvin/ExtendedPotvinEncoding.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/ExtendedPotvin/ExtendedPotvinEncoding.cs	(revision 6851)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/ExtendedPotvin/ExtendedPotvinEncoding.cs	(revision 6851)
@@ -0,0 +1,105 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using System.Drawing;
+using System.Collections.Generic;
+using HeuristicLab.Problems.VehicleRouting.Encodings.General;
+using HeuristicLab.Problems.VehicleRouting.Variants;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+using HeuristicLab.Problems.VehicleRouting.ProblemInstances;
+using HeuristicLab.Problems.VehicleRouting.Encodings.Potvin;
+
+namespace HeuristicLab.Problems.VehicleRouting.Encodings.ExtendedPotvin {
+  [Item("ExtendedPotvinEncoding", "A tour encoding with heterogenous vehicles.")]
+  [StorableClass]
+  public class ExtendedPotvinEncoding : PotvinEncoding {
+    [Storable]
+    public Permutation VehicleAssignment { get; private set; }
+
+    public ExtendedPotvinEncoding(IVRPProblemInstance instance)
+      : base(instance) {
+       VehicleAssignment = new Permutation(PermutationTypes.Absolute, instance.Vehicles.Value);
+    }
+
+    [StorableConstructor]
+    private ExtendedPotvinEncoding(bool serializing)
+      : base(serializing) {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ExtendedPotvinEncoding(this, cloner);
+    }
+
+    protected ExtendedPotvinEncoding(ExtendedPotvinEncoding original, Cloner cloner)
+      : base(original, cloner) {
+        this.VehicleAssignment = cloner.Clone<Permutation>(original.VehicleAssignment);
+    }
+
+    public override int GetVehicleAssignment(int tour) {
+      return VehicleAssignment[tour];
+    }
+
+    public static new ExtendedPotvinEncoding ConvertFrom(IVRPEncoding encoding, IVRPProblemInstance instance) {
+      ExtendedPotvinEncoding solution = new ExtendedPotvinEncoding(instance);
+
+      TourEncoding.ConvertFrom(encoding, solution, instance);
+
+      List<int> vehicles = new List<int>();
+      for (int i = 0; i < instance.Vehicles.Value; i++)
+        vehicles.Add(i);
+
+      int[] assignment = new int[instance.Vehicles.Value];
+      for (int i = 0; i < assignment.Length; i++)
+        assignment[i] = -1;
+
+      for (int i = 0; i < solution.Tours.Count; i++) {
+        int vehicle = encoding.GetVehicleAssignment(i);
+        assignment[i] = vehicle;
+        vehicles.Remove(vehicle);
+      }
+
+      for (int i = 0; i < instance.Vehicles.Value; i++) {
+        if (assignment[i] == -1) {
+          int vehicle = vehicles[0];
+          assignment[i] = vehicle;
+          vehicles.RemoveAt(0);
+        }
+      }
+
+      solution.VehicleAssignment = new Permutation(PermutationTypes.Absolute, assignment);
+
+      return solution;
+    }
+
+    public static new ExtendedPotvinEncoding ConvertFrom(List<int> route, IVRPProblemInstance instance) {
+      ExtendedPotvinEncoding solution = new ExtendedPotvinEncoding(instance);
+
+      TourEncoding.ConvertFrom(route, solution);
+
+      return solution;
+    }
+  }
+}
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/ExtendedPotvin/IExtendedPotvinOperator.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/ExtendedPotvin/IExtendedPotvinOperator.cs	(revision 6851)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/ExtendedPotvin/IExtendedPotvinOperator.cs	(revision 6851)
@@ -0,0 +1,38 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Operators;
+using HeuristicLab.Problems.VehicleRouting.Variants;
+using HeuristicLab.Problems.VehicleRouting.Encodings.Potvin;
+
+namespace HeuristicLab.Problems.VehicleRouting.Encodings.ExtendedPotvin {
+  public interface IExtendedPotvinOperator :
+    IPotvinOperator, IMultiDepotOperator, IHeterogenousCapacitatedOperator {    
+  }
+}
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/ExtendedPotvin/Manipulators/ExtendedPotvinManipulator.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/ExtendedPotvin/Manipulators/ExtendedPotvinManipulator.cs	(revision 6851)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/ExtendedPotvin/Manipulators/ExtendedPotvinManipulator.cs	(revision 6851)
@@ -0,0 +1,99 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.Problems.VehicleRouting.Encodings.General;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+using HeuristicLab.Common;
+using HeuristicLab.Problems.VehicleRouting.Encodings.Potvin;
+
+namespace HeuristicLab.Problems.VehicleRouting.Encodings.ExtendedPotvin {
+  [Item("ExtendedPotvinManipulator", "A VRP manipulation operation.")]
+  [StorableClass]
+  public class ExtendedPotvinManipulator : VRPManipulator, IStochasticOperator, IExtendedPotvinOperator {
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (LookupParameter<IRandom>)Parameters["Random"]; }
+    }
+
+    public IValueParameter<PotvinManipulator> ToursManipuator {
+      get { return (IValueParameter<PotvinManipulator>)Parameters["ToursManipuator"]; }
+    }
+
+    public IValueParameter<IPermutationManipulator> VehicleAssignmentManipuator {
+      get { return (IValueParameter<IPermutationManipulator>)Parameters["VehicleAssignmentManipuator"]; }
+    }
+
+    public IValueParameter<PercentValue> VehicleAssignmentMutationRate {
+      get { return (IValueParameter<PercentValue>)Parameters["VehicleAssignmentMutationRate"];}
+    }
+
+    public ILookupParameter<Permutation> VehicleAssignmentParameter {
+      get { return (ILookupParameter<Permutation>)Parameters["VehicleAssignment"]; }
+    }
+
+    [StorableConstructor]
+    protected ExtendedPotvinManipulator(bool deserializing) : base(deserializing) { }
+
+    public ExtendedPotvinManipulator() {
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic manipulation operators."));
+      Parameters.Add(new ValueParameter<PotvinManipulator>("ToursManipuator",
+         "The operator used to menipulate the tours.", new PotvinCustomerRelocationMainpulator()));
+      Parameters.Add(new ValueParameter<IPermutationManipulator>("VehicleAssignmentManipuator",
+        "The operator used to menipulate the vehicle assignments.", new Swap2Manipulator()));
+      Parameters.Add(new LookupParameter<Permutation>("VehicleAssignment"));
+      Parameters.Add(new ValueParameter<PercentValue>("VehicleAssignmentMutationRate", "The mutation rate of the vehicle assignments", new PercentValue(0.1)));
+    }
+
+    protected ExtendedPotvinManipulator(ExtendedPotvinManipulator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ExtendedPotvinManipulator(this, cloner);
+    }
+
+    public override IOperation Apply()
+    {
+      IVRPEncoding solution = VRPToursParameter.ActualValue;
+      if (!(solution is ExtendedPotvinEncoding)) {
+        VRPToursParameter.ActualValue = ExtendedPotvinEncoding.ConvertFrom(solution, ProblemInstance);
+      }
+
+      OperationCollection next = new OperationCollection(base.Apply());
+
+      ToursManipuator.Value.VRPToursParameter.ActualName = VRPToursParameter.ActualName;
+      next.Insert(0, ExecutionContext.CreateOperation(ToursManipuator.Value));
+
+      if (RandomParameter.ActualValue.NextDouble() < VehicleAssignmentMutationRate.Value.Value) {
+        VehicleAssignmentParameter.ActualValue = (VRPToursParameter.ActualValue as ExtendedPotvinEncoding).VehicleAssignment;
+        VehicleAssignmentManipuator.Value.PermutationParameter.ActualName = VehicleAssignmentParameter.ActualName;
+        next.Insert(1, ExecutionContext.CreateOperation(VehicleAssignmentManipuator.Value));
+      }
+
+      return next;
+    }
+  }
+}
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/GVR/Crossovers/GVRCrossover.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/GVR/Crossovers/GVRCrossover.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/GVR/Crossovers/GVRCrossover.cs	(revision 6851)
@@ -82,5 +82,5 @@
       for (int i = 1; i <= ProblemInstance.Cities.Value; i++) {
         if (!subroute.Contains(i)) {
-          double distance = ProblemInstance.GetDistance(subroute[0], i);
+          double distance = ProblemInstance.GetDistance(subroute[0], i, child);
 
           if (customer == -1 || distance < minDistance) {
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/GVR/GVREncoding.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/GVR/GVREncoding.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/GVR/GVREncoding.cs	(revision 6851)
@@ -42,5 +42,4 @@
         double currentDemand = 0;
 
-        DoubleArray demand = ProblemInstance.Demand;
         DoubleValue capacity = new DoubleValue(double.MaxValue);
         if (ProblemInstance is IHomogenousCapacitatedProblemInstance) {
@@ -50,5 +49,5 @@
 
         foreach (int city in tour.Stops) {
-          currentDemand += demand[city];
+          currentDemand += ProblemInstance.GetDemand(city);
 
           if (currentDemand > capacity.Value) {
@@ -58,5 +57,5 @@
             newTour = new Tour();
             newTour.Stops.Add(city);
-            currentDemand = demand[city];
+            currentDemand = ProblemInstance.GetDemand(city);
           } else {
             newTour.Stops.Add(city);
Index: /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/General/Crossovers/BiasedMultiVRPSolutionCrossover.cs
===================================================================
--- /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/General/Crossovers/BiasedMultiVRPSolutionCrossover.cs	(revision 6850)
+++ /branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/General/Crossovers/BiasedMultiVRPSolutionCrossover.cs	(revision 6851)
@@ -160,5 +160,5 @@
       OperationCollection next = new OperationCollection(successorOp);
       if (successor != null) {
-        SelectedOperatorParameter.ActualValue = new StringValue(successor.GetType().Name);
+        SelectedOperatorParameter.ActualValue = new StringValue(successor.Name);
 
         if (CreateChildOperation)
